MQT = {}
MQT.data = {
	["name"] = "If By Sea",
	["questIndex"] = 4,
	["level"] = 6,
	["text"] = "Get to the Dhalmora Watchtower"
	}


function MQTGetQuestInfoTable()
	local quests = {}
	for questIndex=1, MAX_JOURNAL_QUESTS do
		if IsValidQuestIndex(questIndex) == true then
			quests[questIndex] = {}
			local qi = quests[questIndex]
			qi.questIndex = questIndex
			qi.name, qi.bgText, qi.activeStepText, qi.activeStepType, qi.activeStepTrackerOvrdText, qi.isCompleted, qi.isTracked, qi.questLevel, qi.isPushed, qi.questType = GetJournalQuestInfo(questIndex)
			qi.zoneName, qi.objectiveName, qi.zoneIndex, qi.poiIndex = GetJournalQuestLocationInfo(questIndex)
			qi.conditions = {}
			for stepIndex=1, GetJournalQuestNumSteps(questIndex) do
				local stepText,_,_,trackerOvrdText,numConditions = GetJournalQuestStepInfo()
				if stepText == qi.activeStepText then
					if trackerOvrdText ~= nil then 
						local ci = {}
						ci.conditionText = trackerOvrdText
						table.insert(qi.conditions, ci)
					else
						for conditionIndex=1, GetJournalQuestNumConditions(questIndex, stepIndex) do
							local ci = {}
							ci.conditionText, ci.current, ci.max, ci.isFailCondition, ci.isComplete, ci.isCreditShared = GetJournalQuestConditionInfo(questIndex, stepIndex, conditionIndex)
							table.insert(qi.conditions, ci)
						end
					end
				end
			end
		end	
	end
	return quests
end

function MQTInitialize()
	MQTTree()
	
	MQTquests = MQTGetQuestInfoTable()
	
	for questIndex,questData in pairs(MQTquests) do
		local header = MQT.tree:AddNode("QuestHeader", questData)
			for cIndex,cData in pairs(questData.conditions) do
				MQT.tree:AddNode("QuestEntry", cData, header)
			end
	end
	
end


function MQTTree()
	mqtcont = WINDOW_MANAGER:CreateControl("MQT_Container", MQT_Control, CT_CONTROL)
	mqtcont:SetDimensions(300,400)
	mqtcont:SetAnchor(CENTER,MQT_Control,CENTER)
	mqtcont:SetHidden(false)
	mqtcont:SetMouseEnabled(true)
	mqtcont:SetMovable(true)
	
	local openTexture = "EsoUI/Art/Buttons/pointsMinus_up.dds"
    local closedTexture = "EsoUI/Art/Buttons/pointsPlus_up.dds"
    local overOpenTexture = "EsoUI/Art/Buttons/pointsMinus_over.dds"
    local overClosedTexture = "EsoUI/Art/Buttons/pointsPlus_over.dds"
	
	MQT.tree = ZO_Tree:New(MQT_Container, 80,1, 500)
	
	local function TreeHeaderSetup(node, control, data, open)
        control.text:SetText("["..data.questLevel.."]"..data.name)
        control.icon:SetTexture(open and openTexture or closedTexture)
        control.iconHighlight:SetTexture(open and overOpenTexture or overClosedTexture)
        control.text:SetSelected(open)
    end
    
	MQT.tree:AddTemplate("QuestHeader", TreeHeaderSetup,nil,nil,nil,0 )
	
	
	
	local function TreeEntrySetup(node, control, data, open)
        control:SetText(data.conditionText)
        control.con = GetCon(data.questLevel)
        control.questIndex = data.questIndex
    end
    
    local function TreeEntryOnSelected(control, data, selected, reselectingDuringRebuild)

    end
    
    local function TreeEntryEquality(left, right)
        return left.name == right.name
    end
    
    MQT.tree:AddTemplate("QuestEntry", TreeEntrySetup, TreeEntryOnSelected, TreeEntryEquality)
	

    MQT.tree:SetOpenAnimation("ZO_TreeOpenAnimation")
    
    
	
end



function Header_OnMouseUp(control, upInside)
    if control.node.open == true then control.node:SetOpen(false)
    else control.node:SetOpen(true) end
end

function OnTreeHeaderInitialized(control)
    control.icon = control:GetNamedChild("Icon")
    control.iconHighlight = control.icon:GetNamedChild("Highlight")
    control.text = control:GetNamedChild("Text")
end
